#include <stdio.h>
#include <wiringPi.h>
#include <wiringPiI2C.h>

main() {
    int fd;
    int i;
    int PRESS_OUT;
    int TEMP_OUT;
    float press;
    float temp;

    wiringPiSetup();			  // WiringPi初期化
    fd = wiringPiI2CSetup(0x5c);	  // LPS25Hオープン
    wiringPiI2CWriteReg8(fd, 0x20, 0x90); // 初期化。1秒ごとにデータ取得

    for(;;) {
    	// LPS25Hから気圧取得
    	PRESS_OUT  = wiringPiI2CReadReg8(fd, 0x28);	 // PRESS_OUT_XL
    	PRESS_OUT |= wiringPiI2CReadReg8(fd, 0x29) << 8; // PRESS_OUT_H
    	PRESS_OUT |= wiringPiI2CReadReg8(fd, 0x2a) << 16;// PRESS_OUT_L
    	press = PRESS_OUT / 4096.0;	// 気圧に変換

	// LPS25Hから温度取得
	TEMP_OUT   = wiringPiI2CReadReg8(fd, 0x2b);	 // TEMP_OUT_L
    	TEMP_OUT  |= wiringPiI2CReadReg8(fd, 0x2c) << 8; // TEMP_OUT_H
    	// 16bit符号付き整数 -> システムの符号つき変数へ拡張
    	if ((TEMP_OUT & 0x8000) != 0) TEMP_OUT |= (~0x7fff);
	temp = 42.5 + TEMP_OUT / 480.0;	// 温度に変換

	printf("%4.1f hPa   %2.1f deg\n", press, temp);
	delay(1000);
    }
}


