#include <stdio.h>
#include <wiringPi.h>
#include <wiringPiI2C.h>

main() {
    int fd;
    int i;
    unsigned char buf[4];
    float temperature;
    float humidity;

    wiringPiSetup();			// WiringPi初期化
    fd = wiringPiI2CSetup(0x40);	// I2Cオープン

    // HDC1000初期化
    buf[0]=0x02;	// Configuration Resistor
    buf[1]=0x10;	// MODE 1
    buf[2]=0x00;	// Reserved
    write(fd, buf, 3);

    for(;;) {

    	// HDC1000から温湿度を読み取る
    	buf[0]=0x00;
    	write(fd, buf, 1);	// 0x00にアクセス
    	delay(13);		// ウェイト 6.35ms + 6.5ms = 12.85ms
    	read(fd, buf, 4);	// データ読み出し

    	// 物理量へ変換
    	temperature = (buf[0] << 8 | buf[1]) / 65536.0 * 165.0 - 40;
    	humidity = (buf[2] << 8 | buf[1]) / 65536.0 * 100.0;

    	printf("%2.1f deg   %3.0f %%\n", temperature, humidity);
    }
}
